﻿/* Мною, Константином aka KilkennyCat, 05 июля 2020 года создано сиё 
 * на основе "Описание формата TopoR PCB версия 1.2.0 Апрель 2017 г.".
 * k@kilkennycat.pro
 * http://kilkennycat.ru  http://kilkennycat.pro
 */

using System.Collections.Generic;
using System.Linq;
using System.Xml.Serialization;

namespace TopoR_PCB_Classes
{
    /// <summary>
    /// Раздел «Текущий список соединений».
    /// </summary>
    public class NetList
    {
        /// <summary>
        /// Раздел «Текущий список соединени
        /// </summary>
        public class Net
        {
            /// <summary>
            /// Имя объекта или ссылка на именованный объект.
            /// </summary>
            [XmlAttribute("name")]
            public string _name;

            /// <summary>
            /// Ссылка на контакт или вывод посадочного места (объект класса PinRef или PadRef).
            /// </summary>
            [
                XmlElement("PinRef", typeof(PinRef)),
                XmlElement("PadRef", typeof(PadRef))
            ]
            public List<object> _refs;
            public bool ShouldSerialize_refs()
            {
                return _refs?.Count > 0;
            }
        }
        
        /// <summary>
        /// Версия раздела.
        /// </summary>
        [XmlAttribute("version")]
        public string _version;

        /// <summary>
        /// Описания цепей.
        /// </summary>
        [XmlElement("Net")]
        public List<Net> _Nets;
        public bool ShouldSerialize_Nets()
        {
            return _Nets?.Count > 0;
        }


        /*******************************************************************
         * Здесь находятся функции для работы с элементами класса NetList. *
         * Они не являются частью формата TopoR PCB.                       *
         * *****************************************************************/

        /// <summary>
        /// Переименование ссылок на компонент
        /// </summary>
        /// <param name="oldname">старое имя компонента</param>
        /// <param name="newname">новое имя компонента</param>
        /// <summary>
        public void Rename_compName(string oldname, string newname)
        {
            if (newname == "")
            {
                return;
            }
            foreach (var a in _Nets?.Where(aa => aa._refs != null))
            {
                foreach (var b in a._refs.OfType<PinRef>().Where(bb => bb._compName == oldname))
                {
                    b._compName = newname;
                }
                foreach (var b in a._refs.OfType<PadRef>().Where(bb => bb._compName == oldname))
                {
                    b._compName = newname;
                }
            }
        }

        /// <summary>
        /// Удаление ссылок на компонент
        /// </summary>
        /// <param name="name">имя компонента</param>
        public void Remove_compName(string name)
        {
            bool _ifremove(object o)
            {
                if (o is PinRef)
                {
                    return (o as PinRef)._compName == name;
                }
                if (o is PadRef)
                {
                    return (o as PadRef)._compName == name;
                }
                return false;
            }
            foreach (var a in _Nets?.Where(aa => aa._refs != null))
            { 
                a._refs.RemoveAll(b => _ifremove(b));
            }
        }
        /*******************************************************************/

    }
}
